var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { TDMCollection as ARecordColl } from '@tdm/data';
import { HttpActionMethodType } from '../metadata/index';
import { HttpAction } from '../decorators';
import { HttpDAOActions } from '../core/http-dao';
var HttpActiveRecord = (function () {
    function HttpActiveRecord() {
    }
    return HttpActiveRecord;
}());
export { HttpActiveRecord };
__decorate([
    HttpAction({
        method: HttpActionMethodType.Post,
        validation: /** @type {?} */ ('both'),
        pre: function (ctx, options) {
            ctx.data = ctx.serialize();
            return options;
        }
    }),
    __metadata("design:type", Function)
], HttpActiveRecord.prototype, "$create", void 0);
__decorate([
    HttpAction({
        method: HttpActionMethodType.Get,
        validation: /** @type {?} */ ('incoming')
    }),
    __metadata("design:type", Function)
], HttpActiveRecord.prototype, "$refresh", void 0);
__decorate([
    HttpAction({
        method: HttpActionMethodType.Put,
        validation: /** @type {?} */ ('both'),
        pre: function (ctx, options) {
            ctx.data = ctx.serialize();
            return options;
        }
    }),
    __metadata("design:type", Function)
], HttpActiveRecord.prototype, "$update", void 0);
__decorate([
    HttpAction({
        method: HttpActionMethodType.Delete,
        validation: /** @type {?} */ ('skip')
    }),
    __metadata("design:type", Function)
], HttpActiveRecord.prototype, "$remove", void 0);
__decorate([
    HttpDAOActions.query,
    __metadata("design:type", Function)
], HttpActiveRecord, "query", void 0);
__decorate([
    HttpDAOActions.findById,
    __metadata("design:type", Function)
], HttpActiveRecord, "findById", void 0);
__decorate([
    HttpDAOActions.find,
    __metadata("design:type", Function)
], HttpActiveRecord, "find", void 0);
__decorate([
    HttpDAOActions.create,
    __metadata("design:type", Function)
], HttpActiveRecord, "create", void 0);
__decorate([
    HttpDAOActions.update,
    __metadata("design:type", Function)
], HttpActiveRecord, "update", void 0);
__decorate([
    HttpDAOActions.remove,
    __metadata("design:type", Function)
], HttpActiveRecord, "remove", void 0);
function HttpActiveRecord_tsickle_Closure_declarations() {
    /** @type {?} */
    HttpActiveRecord.query;
    /** @type {?} */
    HttpActiveRecord.findAll;
    /** @type {?} */
    HttpActiveRecord.findById;
    /** @type {?} */
    HttpActiveRecord.find;
    /** @type {?} */
    HttpActiveRecord.findOne;
    /** @type {?} */
    HttpActiveRecord.create;
    /** @type {?} */
    HttpActiveRecord.update;
    /** @type {?} */
    HttpActiveRecord.remove;
    /** @type {?} */
    HttpActiveRecord.prototype.$create;
    /** @type {?} */
    HttpActiveRecord.prototype.$refresh;
    /** @type {?} */
    HttpActiveRecord.prototype.$update;
    /** @type {?} */
    HttpActiveRecord.prototype.$remove;
}
export var /** @type {?} */ ActiveRecordCollection = ARecordColl;
//# sourceMappingURL=http-active-record.js.map