var /** @type {?} */ ngHttpService;
/**
 * @return {?}
 */
export function getHttp() {
    if (!ngHttpService) {
        throw new Error('Http service not present. Make sure you registered the provider and you are not invoking actions before angular bootstrapped.');
    }
    else {
        return ngHttpService;
    }
}
/**
 * @param {?} http
 * @return {?}
 */
export function runAfterBootstrap(http) {
    ngHttpService = http;
    return function () { };
}
//# sourceMappingURL=providers.js.map