import { Type } from '@tdm/tixin';
import { TDMModel } from '@tdm/data';
import { HttpActiveRecord, HttpActiveRecordStatic } from './http-active-record';
export declare function ARMixin<Model, TypeofModel>(): Type<Model & TDMModel<Model> & HttpActiveRecord> & TypeofModel & HttpActiveRecordStatic<Model> & typeof HttpActiveRecord;
export declare function ARMixin<Model, TypeofModel>(model: TypeofModel & Type<Model>): Type<Model & TDMModel<Model> & HttpActiveRecord> & TypeofModel & HttpActiveRecordStatic<Model> & typeof HttpActiveRecord;
export declare function ARMixin<Model, TypeofModel, T1, C1>(model: TypeofModel & Type<Model>, m1: C1 & Type<T1>): Type<Model & HttpActiveRecord & T1> & TypeofModel & typeof HttpActiveRecord & HttpActiveRecordStatic<Model> & C1;
export declare function ARMixin<Model, TypeofModel, T1, C1, T2, C2>(model: TypeofModel & Type<Model>, m1: C1 & Type<T1>, m2: C2 & Type<T2>): Type<Model & TDMModel<Model> & HttpActiveRecord & T1 & T2> & TypeofModel & typeof HttpActiveRecord & HttpActiveRecordStatic<Model> & C1 & C2;
export declare function ARMixin<Model, TypeofModel, T1, C1, T2, C2, T3, C3>(model: TypeofModel & Type<Model>, m1: C1 & Type<T1>, m2: C2 & Type<T2>, m3: C3 & Type<T3>): Type<Model & TDMModel<Model> & HttpActiveRecord & T1 & T2 & T3> & TypeofModel & typeof HttpActiveRecord & HttpActiveRecordStatic<Model> & C1 & C2 & C3;
export declare function ARMixin<Model, TypeofModel, T1, C1, T2, C2, T3, C3, T4, C4>(model: TypeofModel & Type<Model>, m1: C1 & Type<T1>, m2: C2 & Type<T2>, m3: C3 & Type<T3>, m4: C4 & Type<T4>): Type<Model & TDMModel<Model> & HttpActiveRecord & T1 & T2 & T3 & T4> & TypeofModel & typeof HttpActiveRecord & HttpActiveRecordStatic<Model> & C1 & C2 & C3 & C4;
export declare function ARMixin<Model, TypeofModel, T1, C1, T2, C2, T3, C3, T4, C4, T5, C5>(model: TypeofModel & Type<Model>, m1: C1 & Type<T1>, m2: C2 & Type<T2>, m3: C3 & Type<T3>, m4: C4 & Type<T4>, m5: C5 & Type<T5>): Type<Model & TDMModel<Model> & HttpActiveRecord & T1 & T2 & T3 & T4 & T5> & TypeofModel & typeof HttpActiveRecord & HttpActiveRecordStatic<Model> & C1 & C2 & C3 & C4 & C5;
export declare function ARMixin<Model, TypeofModel, T1, C1, T2, C2, T3, C3, T4, C4, T5, C5, T6, C6>(model: TypeofModel & Type<Model>, m1: C1 & Type<T1>, m2: C2 & Type<T2>, m3: C3 & Type<T3>, m4: C4 & Type<T4>, m5: C5 & Type<T5>, m6: C6 & Type<T6>): Type<Model & TDMModel<Model> & HttpActiveRecord & T1 & T2 & T3 & T4 & T5 & T6> & TypeofModel & typeof HttpActiveRecord & HttpActiveRecordStatic<Model> & C1 & C2 & C3 & C4 & C5 & C6;
export declare function ARMixin<Model, TypeofModel, T1, C1, T2, C2, T3, C3, T4, C4, T5, C5, T6, C6, T7, C7>(model: TypeofModel & Type<Model>, m1: C1 & Type<T1>, m2: C2 & Type<T2>, m3: C3 & Type<T3>, m4: C4 & Type<T4>, m5: C5 & Type<T5>, m6: C6 & Type<T6>, m7: C7 & Type<T7>): Type<Model & TDMModel<Model> & HttpActiveRecord & T1 & T2 & T3 & T4 & T5 & T6 & T7> & TypeofModel & typeof HttpActiveRecord & HttpActiveRecordStatic<Model> & C1 & C2 & C3 & C4 & C5 & C6 & C7;
export declare type ARMixin<Model> = Model & TDMModel<Model> & HttpActiveRecord;
