var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { MetaClass } from '@tdm/core/tdm';
import { ActionMetadata } from '@tdm/data';
import { HttpAdapter } from '../core/index';
import { mapMethod } from './method-mapper';
var HttpActionMetadata = (function (_super) {
    __extends(HttpActionMetadata, _super);
    /**
     * @param {?} obj
     * @param {?} info
     */
    function HttpActionMetadata(obj, info) {
        var _this = _super.call(this, obj, info) || this;
        if (!obj.hasOwnProperty('method')) {
            throw new Error('Resource Action method is mandatory.');
        }
        _this.methodInfo = mapMethod(obj.method);
        _this.method = _this.methodInfo.method;
        return _this;
    }
    return HttpActionMetadata;
}(ActionMetadata));
HttpActionMetadata.adapterClass = HttpAdapter;
HttpActionMetadata = __decorate([
    MetaClass({
        allowOn: ['staticMember', 'member'],
        extend: ActionMetadata.extend,
        register: ActionMetadata.register
    }),
    __metadata("design:paramtypes", [Object, Object])
], HttpActionMetadata);
export { HttpActionMetadata };
function HttpActionMetadata_tsickle_Closure_declarations() {
    /** @type {?} */
    HttpActionMetadata.adapterClass;
    /** @type {?} */
    HttpActionMetadata.prototype.methodInfo;
    /** @type {?} */
    HttpActionMetadata.prototype.endpoint;
    /** @type {?} */
    HttpActionMetadata.prototype.urlParams;
    /** @type {?} */
    HttpActionMetadata.prototype.headers;
    /** @type {?} */
    HttpActionMetadata.prototype.withCredentials;
    /** @type {?} */
    HttpActionMetadata.prototype.trailingSlashes;
}
//# sourceMappingURL=action.js.map