import { ActionMethodType } from '@tdm/data';
export declare enum HttpActionMethodType {
    Get = 0,
    Post = 1,
    Put = 2,
    Delete = 3,
    Options = 4,
    Head = 5,
    Patch = 6,
}
export interface MappedMethod {
    method: ActionMethodType;
    source: HttpActionMethodType;
    local: boolean;
}
export declare function mapMethod(method: HttpActionMethodType): MappedMethod;
