import { targetStore } from '@tdm/core/tdm';
import { DAO } from '@tdm/data';
import { HttpDao } from './core/http-dao';
import { HttpAdapter } from './core/index';
import { HttpActionMetadata, HttpResourceMetadata } from './metadata/index';
targetStore.registerAdapter(HttpAdapter, {
    actionMetaClass: HttpActionMetadata,
    DAOClass: HttpDao,
    resourceMetaClass: HttpResourceMetadata
});
/**
 * An HttpDAO factory based for a target.
 */
var NgDAO = (function () {
    function NgDAO() {
    }
    /**
     * @template T, Z
     * @param {?} target
     * @return {?}
     */
    NgDAO.prototype.get = function (target) {
        return DAO.of(HttpAdapter, target);
    };
    return NgDAO;
}());
export { NgDAO };
DAO.angularHttp = NgDAO.prototype.get;
//# sourceMappingURL=register.js.map